import java.util.*;
import java.io.*;

// Задача "Свадьба"
// 10-ая Интернет-олимпиада сезона 2006-2007, базовый уровень
// Автор условия: Виталий Гольдштейн
// Автор решения: Максим Буздалов, buzdalov@rain.ifmo.ru

public class wedding_mb {
    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        Scanner in = new Scanner(new File("wedding.in"));
        int N = in.nextInt();

        assert 1 <= N && N <= 40;

        int[] sums = new int[N];
        for (int i = 0; i < N; i++) {
            sums[i] = in.nextInt();
            assert 0 <= sums[i] && sums[i] <= 1000000000;
        }

        int now = in.nextInt();
        assert 0 <= now && now <= 1000000000;

        in.close();

        double answer = now;

        Arrays.sort(sums);
        for (int i = 0; i < N; i++) {
            if (sums[i] > answer) {
                answer = (sums[i] + answer) / 2;
            }
        }

        PrintWriter out = new PrintWriter("wedding.out");
        out.println(answer);
        out.close();
    }
}
